## yoshimi 0.058.1

=== src/CMakeLists.txt ===
#
#   CMakeLists.txt
#
#   Copyright 2009-2010, Alan Calvert
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 3 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

project(Yoshimi)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)
cmake_policy(SET CMP0004 OLD)
set(YOSHIMI_VERSION "0.058.1")
file(WRITE version.txt "${YOSHIMI_VERSION}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_USE_RELATIVE_PATHS OFF)
    # relative paths break some scripts(?)
set(CMAKE_SKIP_RULE_DEPENDENCY OFF)
    # Rebuild objects if rules have changed, even if source hasn't.

# User options
set(DEFAULT_AUDIO jack CACHE STRING "Default audio driver - alsa or jack")
set(DEFAULT_MIDI jack CACHE STRING "Default midi driver - alsa or jack")
option(BUILD_X86_64 "Build for x86_64 system" OFF)
option(USE_ASM_F21 "Use assembler FLOAT to INT conversions" ON)
option(DEBUG_BUILD "Include gdb debug support" OFF)
set(YOSHI_FIFO_DIR /dev/shm CACHE STRING "Directory for fifos")

set(BUILD_X86_64_OPTS
    # "-march=native
    "-O3 -march=athlon64 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
    CACHE STRING "X86_64 complier options"
)
set(BUILD_OPTS
    "-O3 -march=native -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "X86 complier options"
)

set(BUILD_DEBUG_OPTS "-O0 -g3 -ggdb -Wall -Wpointer-arith"
    CACHE STRING "Debug build flags")

# Zyn parameters
set(ZynMaxAdHarmonics 128 CACHE STRING
    "number of harmonics of additive synth - must be less than half Oscilsize" FORCE)
add_definitions(-DMAX_AD_HARMONICS=${ZynMaxAdHarmonics})

set(ZynMaxSubHarmonics 64 CACHE STRING "number of harmonics of substractive" FORCE)
add_definitions(-DMAX_SUB_HARMONICS=${ZynMaxSubHarmonics})

set(ZynMaxPadSamples 64 CACHE STRING "maximum samples per PADsynth instrument (or item)" FORCE)
add_definitions(-DPAD_MAX_SAMPLES=${ZynMaxPadSamples})

set(ZynMidiParts 16 CACHE STRING "maximum number of midi parts" FORCE)
add_definitions(-DNUM_MIDI_PARTS=${ZynMidiParts})

set(ZynMidiChannels 16 CACHE STRING "maximum number of midi channels" FORCE)
add_definitions(-DNUM_MIDI_CHANNELS=${ZynMidiChannels})

set(ZynNumVoices 8 CACHE STRING "number of voices of additive synth for a single note" FORCE)
add_definitions(-DNUM_VOICES=${ZynNumVoices})

set(ZynPoliphony 60 CACHE STRING "The poliphony (notes)" FORCE)
add_definitions(-DPOLIPHONY=${ZynPoliphony})

set(ZynNumSysEfx 4 CACHE STRING "Number of system effects" FORCE)
add_definitions(-DNUM_SYS_EFX=${ZynNumSysEfx})

set(ZynNumInsertionEfx 8 CACHE STRING "Number of insertion effects" FORCE)
add_definitions(-DNUM_INS_EFX=${ZynNumInsertionEfx})

set(ZynNumPartEfx 3 CACHE STRING "Number of part effects" FORCE)
add_definitions(-DNUM_PART_EFX=${ZynNumPartEfx})

set(ZynNumKitItems 16 CACHE STRING "Maximum number of instruments per part" FORCE)
add_definitions(-DNUM_KIT_ITEMS=${ZynNumKitItems})

set(ZynVelocityMaxScale 8.0 CACHE STRING "How is applied the velocity sensing" FORCE)
add_definitions(-DVELOCITY_MAX_SCALE=${ZynVelocityMaxScale})

set(ZynMaxEqBands 8 CACHE STRING "maximum number of bands of the equaliser" FORCE)
if (${ZynMaxEqBands} GREATER 19)
    message(FATAL_ERROR "ZynMaxEqBands too high, must be less than 20")
endif (${ZynMaxEqBands} GREATER 19)
add_definitions(-DMAX_EQ_BANDS=${ZynMaxEqBands})

set(ZynMaxFilterStages 5 CACHE STRING "Maximum filter stages" FORCE)
add_definitions(-DMAX_FILTER_STAGES=${ZynMaxFilterStages})

set(ZynMaxVowels 6 CACHE STRING "Maximum formant filter vowels" FORCE)
add_definitions(-DFF_MAX_VOWELS=${ZynMaxVowels})

set(ZynMaxFormants 12 CACHE STRING "Maximum formant filter formants" FORCE)
add_definitions(-DFF_MAX_FORMANTS=${ZynMaxFormants})

set(ZynMaxSequence 8 CACHE STRING "Maximum formant filter sequence" FORCE)
add_definitions(-DFF_MAX_SEQUENCE=${ZynMaxSequence})
add_definitions(-DPI=3.1415926536f -DLOG_2=0.693147181f)


mark_as_advanced(EXECUTABLE_OUTPUT_PATH)
mark_as_advanced(LIBRARY_OUTPUT_PATH)
mark_as_advanced(CMAKE_BUILD_TYPE)
mark_as_advanced(CMAKE_INSTALL_PREFIX)

set(PRELUDE "Building Yoshimi version ${YOSHIMI_VERSION} for ${CMAKE_SYSTEM_NAME}")

if(DEBUG_BUILD)
    set(CMAKE_BUILD_TYPE "Debug")
    set(CMAKE_CXX_FLAGS_DEBUG ${BUILD_DEBUG_OPTS})
    message(STATUS "${PRELUDE} with gdb debug information")
    message(STATUS "Debug build flags: ${CMAKE_CXX_FLAGS_DEBUG}")
else(DEBUG_BUILD)
    set(CMAKE_BUILD_TYPE "Release")
    if(BUILD_X86_64)
        set(CMAKE_CXX_FLAGS_RELEASE ${BUILD_X86_64_OPTS})
    else(BUILD_X86_64)
        set(CMAKE_CXX_FLAGS_RELEASE ${BUILD_OPTS})
    endif(BUILD_X86_64)
    message(STATUS "${PRELUDE} without debug information")
    message(STATUS "Build flags: ${CMAKE_CXX_FLAGS_RELEASE}")
endif(DEBUG_BUILD)

# library dependency checks
# PKG-CONFIG
find_package(PkgConfig REQUIRED)
if(PKG_CONFIG_FOUND)
    message(STATUS "Found pkg-config ${PKG_CONFIG_EXECUTABLE}")
else(PKG_CONFIG_FOUND)
    message(FATAL_ERROR "pkg-config required but not found")
endif(PKG_CONFIG_FOUND)

# libz
include(CheckCSourceCompiles)
set(CMAKE_REQUIRED_LIBRARIES z)
check_c_source_compiles(
    "#include <zlib.h>
     int main(int argc, char **argv) {
         gzFile zzz  = gzopen(\"/dev/null\", \"rb\");
         if (NULL != zzz)
            gzclose(zzz);
         return 0;
     }" HAS_LIBZ
)
if(HAS_LIBZ)
    message(STATUS "Found libz")
    set(YOSHI_LIBRARIES ${YOSHI_LIBRARIES} z)
else(HAS_LIBZ)
    message(FATAL_ERROR "libz required but not found: ${HAS_LIBZ}")
endif(HAS_LIBZ)

# fontconfig
pkg_check_modules(FONTCONFIG REQUIRED fontconfig>=0.22)
mark_as_advanced(FONTCONFIG_LIBRARIES)
if(FONTCONFIG_FOUND)
    message(STATUS "Found fontconfig ${FONTCONFIG_VERSION}")
else(FONTCONFIG_FOUND)
    message(FATAL_ERROR "fontconfig>=0.22 required but not found")
endif(FONTCONFIG_FOUND)

# fltk
find_package(FLTK REQUIRED)
if(FLTK_FOUND)
    message(STATUS "Found fltk")
else(FLTK_FOUND)
    message(FATAL_ERROR "FLTK required but not found")
endif(FLTK_FOUND)
mark_as_advanced(FLTK_DIR)
mark_as_advanced(FLTK_FLUID_EXECUTABLE)
mark_as_advanced(FLTK_MATH_LIBRARY)
set (FLTK_sources
   UI/WidgetPDialUI.fl  UI/PresetsUI.fl  UI/EnvelopeUI.fl
   UI/LFOUI.fl  UI/FilterUI.fl  UI/VirKeyboardUI.fl
   UI/ConfigUI.fl  UI/SUBnoteUI.fl  UI/ResonanceUI.fl
   UI/OscilGenUI.fl  UI/ADnoteUI.fl  UI/PADnoteUI.fl
   UI/EffUI.fl  UI/BankUI.fl  UI/PartUI.fl
   UI/MicrotonalUI.fl  UI/MasterUI.fl  UI/MasterMiscUI.fl
   UI/GuiThreadUI.fl UI/ParametersUI.fl UI/ConsoleUI.fl
)
fltk_wrap_ui(yoshimi ${FLTK_sources})
set_source_files_properties(UI/MasterUI.h PROPERTIES GENERATED 1)
set(YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})
set(YOSHI_SOURCES ${yoshimi_FLTK_UI_SRCS})
set(YOSHI_LIBRARIES ${YOSHI_LIBRARIES} ${FLTK_LIBRARIES})

# fftw3
pkg_check_modules(FFTW3 REQUIRED fftw3>=0.22)
if(FFTW3_FOUND)
    set(FFTW3_LIBRARIES "${FFTW3_LIBRARIES};fftw3_threads;pthread")
    message(STATUS "Found fftw3 ${FFTW3_VERSION}")
else(FFTW3_FOUND)
    message(FATAL_ERROR "fftw3 >=0.22 required but not found")
endif(FFTW3_FOUND)

# mxml
pkg_check_modules(MXML REQUIRED mxml>=2.5)
if(MXML_FOUND)
    message(STATUS "Found mxml ${MXML_VERSION}")
else(MXML_FOUND)
    message(FATAL_ERROR "mxml >=2.5 required but not found")
endif(MXML_FOUND)

# Alsa
pkg_check_modules(ALSA REQUIRED alsa>=1.0.17)
if(ALSA_FOUND)
    message(STATUS "Found Alsa ${ALSA_VERSION}")
else(ALSA_FOUND)
    message(FATAL_ERROR "Alsa >=1.0.17 required but not found")
endif(ALSA_FOUND)

# Jack
pkg_check_modules(JACK REQUIRED jack>=0.115.6)
if(JACK_FOUND)
    message(STATUS "Found jack ${JACK_VERSION}")
else(JACK_FOUND)
    message(FATAL_ERROR "Jack >=0.115.6 required but not found")
endif(JACK_FOUND)

# libsndfile
pkg_check_modules(LIBSNDFILE REQUIRED sndfile)
if(LIBSNDFILE_FOUND)
    message(STATUS "Found libsndfile ${LIBSNDFILE_VERSION}")
else(LIBSNDFILE_FOUND)
    message(FATAL_ERROR "libsndfile required but not found")
endif(LIBSNDFILE_FOUND)

set (DSP_sources
    DSP/FFTwrapper.cpp  DSP/AnalogFilter.cpp  DSP/FormantFilter.cpp
    DSP/SVFilter.cpp  DSP/Filter.cpp
)

set(Effects_sources
    Effects/Alienwah.cpp  Effects/Chorus.cpp  Effects/Echo.cpp
    Effects/Effect.cpp  Effects/EffectLFO.cpp  Effects/EffectMgr.cpp
    Effects/Phaser.cpp  Effects/Reverb.cpp  Effects/EQ.cpp
    Effects/Distorsion.cpp  Effects/DynamicFilter.cpp
)

set(Misc_sources
    Misc/Bank.cpp  Misc/Master.cpp  Misc/Microtonal.cpp  Misc/Part.cpp
    Misc/Util.cpp  Misc/Config.cpp  Misc/XMLwrapper.cpp
)

set(Params_sources
    Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
    Params/FilterParams.cpp  Params/LFOParams.cpp
    Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
    Params/Controller.cpp  Params/Presets.cpp
    Params/PresetsStore.cpp
)

set(Synth_sources
    Synth/ADnote.cpp  Synth/Envelope.cpp  Synth/LFO.cpp  Synth/OscilGen.cpp
    Synth/SUBnote.cpp  Synth/Resonance.cpp  Synth/PADnote.cpp
)

set(MusicIO_sources
    MusicIO/MusicClient.cpp  MusicIO/MusicIO.cpp  MusicIO/JackEngine.cpp
    MusicIO/AlsaEngine.cpp  MusicIO/JackClient.cpp  MusicIO/AlsaClient.cpp
    MusicIO/JackAlsaClient.cpp  MusicIO/AlsaJackClient.cpp MusicIO/WavRecord.cpp
)

add_definitions(
    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
    ${ALSA_LDFLAGS}
    ${JACK_LDFLAGS}
    -DYOSHI_FIFO_DIR="${YOSHI_FIFO_DIR}"
)

if(${DEFAULT_AUDIO} STREQUAL "jack")
    message(STATUS "Default audio driver is Jack")
    add_definitions(-DDEFAULT_AUDIO=jack_audio)
elseif(${DEFAULT_AUDIO} STREQUAL "alsa")
    message(STATUS "Default audio driver is Alsa")
    add_definitions(-DDEFAULT_AUDIO=alsa_audio)
else(${DEFAULT_AUDIO} STREQUAL "alsa")
    message(FATAL_ERROR "Invalid DEFAULT_AUDIO selection: " ${DEFAULT_AUDIO})
endif(${DEFAULT_AUDIO} STREQUAL "jack")

if(${DEFAULT_MIDI} STREQUAL "jack")
    message(STATUS "Default midi driver is Jack")
    add_definitions(-DDEFAULT_MIDI=jack_midi)
elseif(${DEFAULT_MIDI} STREQUAL "alsa")
    message(STATUS "Default midi driver is Alsa")
    add_definitions(-DDEFAULT_MIDI=alsa_midi)
else(${DEFAULT_MIDI} STREQUAL "alsa")
    message(FATAL_ERROR "Invalid DEFAULT_MIDI selection: " ${DEFAULT_MIDI})
endif(${DEFAULT_MIDI} STREQUAL "jack")

if(USE_ASM_F21)
    add_definitions(-DASM_F2I)
endif(USE_ASM_F21)

set(YOSHI_INCLUDES
    ${YOSHI_INCLUDES}
    ${FONTCONFIG_INCLUDE_DIRS}
    ${FFTW3_INC_DIR}
    ${MXML_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
)

set(YOSHI_SOURCES
    ${YOSHI_SOURCES}
    ${DSP_sources}
    ${Effects_sources}
    ${Misc_sources}
    ${Params_sources}
    ${Synth_sources}
    ${MusicIO_sources}
)

set(YOSHI_LIBRARIES
    ${YOSHI_LIBRARIES}
    ${FONTCONFIG_LIBRARIES}
    ${FFTW3_LIBRARIES}
    ${MXML_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${JACK_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
)

include_directories(AFTER ${YOSHI_INCLUDES})

add_executable(yoshimi ${YOSHI_SOURCES} main.cpp)

target_link_libraries(yoshimi ${YOSHI_LIBRARIES})

install(TARGETS yoshimi RUNTIME DESTINATION bin)

install(DIRECTORY ../banks DESTINATION share/yoshimi
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ GROUP_WRITE
        WORLD_READ
    DIRECTORY_PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_WRITE GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

set_directory_properties(PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_SOURCE_DIR}/*UI.c* ${CMAKE_SOURCE_DIR}/src/*UI.h"
)

add_custom_target(showversion
    COMMAND echo -n "Version: "

=== debian/changelog ===
yoshimi (0.058.1-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards.
  * Add .gitignore file.
  * Add patch to make yoshimi stores user settings under ~/.config/yoshimi.
  * Add debian/gbp.conf file.

 -- Alessio Treglia <alessio@debian.org>  Mon, 12 Jul 2010 18:06:40 +0200

yoshimi (0.058-1) unstable; urgency=low

  [ Jaromír Mikeš ]
  * Recommends on yoshimi for yoshimi-data package added (Closes: #584644).

  [ Alessio Treglia ]
  * New upstream release.

 -- Alessio Treglia <alessio@debian.org>  Sun, 06 Jun 2010 20:26:45 +0200

yoshimi (0.056-2) unstable; urgency=low

  * Add --as-needed to linking options.
  * Drop GCC options which are not supported on all architectures;
    only i386 and amd64 support some of them (Closes: #584492).

 -- Alessio Treglia <alessio@debian.org>  Fri, 04 Jun 2010 03:14:10 +0200

yoshimi (0.056-1) unstable; urgency=low

  * Initial release (Closes: #581155). 

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 01 May 2010 16:18:45 +0200

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends: debhelper (>= 7.0.50~),
 cmake,
 sharutils,
 libx11-dev,
 fluid,
 libfltk1.1-dev,
 libmxml-dev,
 libfftw3-dev,
 libsndfile1-dev,
 libjack-dev,
 libasound2-dev,
 libfontconfig1-dev,
 dpkg-dev (>= 1.14.17),
 libxinerama-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev
DM-Upload-Allowed: yes
Standards-Version: 3.9.0
Vcs-Git: git://git.debian.org/git/pkg-multimedia/yoshimi.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/yoshimi.git
Homepage: http://yoshimi.sourceforge.net

Package: yoshimi
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 yoshimi-data,
 jackd
Description: A software synthesizer based on ZynAddSubFX
 A software synthesizer for Linux, based on ZynAddSubFX 2.4.0
 .
 Yoshimi delivers the same synthesizer capabilities along with 
 very good Jack and Alsa midi/audio functionality on Linux.

Package: yoshimi-data
Architecture: all
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Presets for Yoshimi
 Yoshimi - a software synthesizer for Linux, based on ZynAddSubFX 2.4.0
 .
 Yoshimi delivers the same synthesizer capabilities along with 
 very good Jack and Alsa midi/audio functionality on Linux.

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed

ifneq (,$(findstring :$(DEB_HOST_ARCH_CPU):,:amd64:))
CXXFLAGS+=-msse -msse2 -mfpmath=sse
endif

%:
	dh --sourcedirectory=src $@

override_dh_installchangelogs:
	dh_installchangelogs README.txt

override_dh_install:
	dh_install
	uudecode $(CURDIR)/debian/yoshimi.uu
	install -d $(CURDIR)/debian/yoshimi/usr/share/applications
	install -d $(CURDIR)/debian/yoshimi/usr/share/icons
	install -m 644 $(CURDIR)/debian/yoshimi.desktop $(CURDIR)/debian/yoshimi/usr/share/applications
	install -m 644 $(CURDIR)/yoshimi.png $(CURDIR)/debian/yoshimi/usr/share/icons

## yoshimi 0.060.5

=== src/CMakeLists.txt ===
#
#   CMakeLists.txt
#
#   Copyright 2009-2010, Alan Calvert
#
#   This file is part of yoshimi, which is free software: you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation, either
#   version 3 of the License, or (at your option) any later version.
#
#   yoshimi is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with yoshimi.  If not, see <http://www.gnu.org/licenses/>.

project (Yoshimi)
cmake_minimum_required (VERSION 2.6)
cmake_policy (VERSION 2.6)
cmake_policy (SET CMP0004 OLD)
set (YOSHIMI_VERSION "0.060.5")
file (WRITE version.txt "${YOSHIMI_VERSION}")

set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_USE_RELATIVE_PATHS OFF)
    # relative paths break some scripts(?)
set (CMAKE_SKIP_RULE_DEPENDENCY OFF)
    # Rebuild objects if rules have changed, even if source hasn't.

message (STATUS "Building Yoshimi version ${YOSHIMI_VERSION} for ${CMAKE_SYSTEM_NAME}")

include (CheckCSourceCompiles)

mark_as_advanced (EXECUTABLE_OUTPUT_PATH)
mark_as_advanced (LIBRARY_OUTPUT_PATH)
mark_as_advanced (CMAKE_BUILD_TYPE)
mark_as_advanced (CMAKE_INSTALL_PREFIX)

# Check for jack session availability
check_c_source_compiles (
    "#include <jack/session.h>
    int main(int argc, char **argv)
    {
        jack_session_event_type_t x = JackSessionSave;
        return 0;
    }" HAS_JACK_SESSION
)

if (HAS_JACK_SESSION)
    option (JackSessionSupport "Include Jack Session Support" ON)
else (HAS_JACK_SESSION)
    option (JackSessionSupport "Include Jack Session Support" OFF)
endif (HAS_JACK_SESSION)

set (DefaultAudio jack CACHE STRING "Default audio driver - alsa or jack")
set (DefaultMidi jack CACHE STRING "Default midi driver - alsa or jack")

option (BuildForAMD_X86_64 "Build for AMD x86_64 system" OFF)
option (BuildForCore2_X86_64 "Build for Intel Core2 x86_64 system" OFF)
option (BuildForDebug "Include gdb debugging support" OFF)

set (FifoDirectory /dev/shm CACHE STRING "Directory for fifos")

set (BuildOptions_x86_64AMD
    "-O3 -march=athlon64 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptions_X86_64Core2
    "-O3 -march=core2 -m64 -Wall -ffast-math -fno-finite-math-only -fomit-frame-pointer"
  CACHE STRING "X86_64 compiler options"
)

set (BuildOptionsBasic
    "-O3 -msse -msse2 -mfpmath=sse -ffast-math -fomit-frame-pointer"
    CACHE STRING "basic X86 complier options"
)

set (BuildOptionsDebug
    "-O0 -g3 -ggdb -Wall -Wpointer-arith" CACHE STRING "Debug build flags")

find_package (PkgConfig REQUIRED)
if (PKG_CONFIG_FOUND)
    message(STATUS "Found pkg-config ${PKG_CONFIG_EXECUTABLE}")
else (PKG_CONFIG_FOUND)
    message(FATAL_ERROR "pkg-config required but not found")
endif (PKG_CONFIG_FOUND)

# libz
set (CMAKE_REQUIRED_LIBRARIES z)
check_c_source_compiles (
    "#include <zlib.h>
     int main(int argc, char **argv) {
         gzFile zzz  = gzopen(\"/dev/null\", \"rb\");
         if (NULL != zzz)
            gzclose(zzz);
         return 0;
     }" HAS_LIBZ
)
if (HAS_LIBZ)
    message(STATUS "Found libz")
else (HAS_LIBZ)
    message(FATAL_ERROR "libz required but not found: ${HAS_LIBZ}")
endif (HAS_LIBZ)

# fftw3f
pkg_check_modules (FFTW3F REQUIRED fftw3f>=0.22)
if (FFTW3F_FOUND)
    set (FFTW3F_LIBRARIES "${FFTW3F_LIBRARIES};fftw3f_threads")
    message (STATUS "Found fftw3f ${FFTW3F_VERSION}")
else (FFTW3F_FOUND)
    message (FATAL_ERROR "fftw3f >=0.22 required but not found")
endif (FFTW3F_FOUND)

# mxml
pkg_check_modules (MXML REQUIRED mxml>=2.5)
if (MXML_FOUND)
    message(STATUS "Found mxml ${MXML_VERSION}")
else (MXML_FOUND)
    message(FATAL_ERROR "mxml >=2.5 required but not found")
endif (MXML_FOUND)

# Alsa
pkg_check_modules (ALSA REQUIRED alsa>=1.0.17)
if (ALSA_FOUND)
    message(STATUS "Found Alsa ${ALSA_VERSION}")
else (ALSA_FOUND)
    message(FATAL_ERROR "Alsa >=1.0.17 required but not found")
endif (ALSA_FOUND)

# Jack
pkg_check_modules (JACK REQUIRED jack>=0.115.6)
if (JACK_FOUND)
    message(STATUS "Found jack ${JACK_VERSION}")
else (JACK_FOUND)
    message(FATAL_ERROR "Jack >=0.115.6 required but not found")
endif (JACK_FOUND)

# Boost
find_package (Boost)
if (Boost_FOUND)
    message(STATUS "Found boost headers version " ${Boost_VERSION})
else (Boost_FOUND)
    message (FATAL_ERROR "boost headers required, but not found")
endif (Boost_FOUND)

# libsndfile
pkg_check_modules (LIBSNDFILE REQUIRED sndfile)
if (LIBSNDFILE_FOUND)
    message (STATUS "Found libsndfile ${LIBSNDFILE_VERSION}")
else (LIBSNDFILE_FOUND)
    message (FATAL_ERROR "libsndfile required but not found")
endif (LIBSNDFILE_FOUND)

# fontconfig
pkg_check_modules (FONTCONFIG REQUIRED fontconfig>=0.22)
mark_as_advanced(FONTCONFIG_LIBRARIES)
if(FONTCONFIG_FOUND)
    message (STATUS "Found fontconfig ${FONTCONFIG_VERSION}")
else(FONTCONFIG_FOUND)
    message (FATAL_ERROR "fontconfig>=0.22 required but not found")
endif(FONTCONFIG_FOUND)

# fltk
find_package (FLTK REQUIRED)
if (FLTK_FOUND)
    message (STATUS "Found FLTK")
else (FLTK_FOUND)
    message (FATAL_ERROR "FLTK required but not found")
endif (FLTK_FOUND)
mark_as_advanced (FLTK_DIR)
mark_as_advanced (FLTK_FLUID_EXECUTABLE)
mark_as_advanced (FLTK_MATH_LIBRARY)
set (GuiFluids
    UI/WidgetPDialUI.fl  UI/PresetsUI.fl  UI/EnvelopeUI.fl
    UI/LFOUI.fl  UI/FilterUI.fl  UI/VirKeyboardUI.fl
    UI/ConfigUI.fl  UI/SUBnoteUI.fl  UI/ResonanceUI.fl
    UI/OscilGenUI.fl  UI/ADnoteUI.fl  UI/PADnoteUI.fl
    UI/EffUI.fl  UI/BankUI.fl  UI/PartUI.fl
    UI/MicrotonalUI.fl  UI/MasterUI.fl    UI/MasterMiscUI.fl
    UI/ParametersUI.fl UI/ConsoleUI.fl
)

fltk_wrap_ui (yoshimi ${GuiFluids})
set_source_files_properties (UI/MasterUI.h PROPERTIES GENERATED 1)
set (YOSHI_INCLUDES ${FLTK_INCLUDE_DIR})

if (BuildForDebug)
    set (CMAKE_BUILD_TYPE "Debug")
    set (CMAKE_CXX_FLAGS_DEBUG ${BuildOptionsDebug})
    message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_DEBUG}")
else (BuildForDebug)
    set (CMAKE_BUILD_TYPE "Release")
    if (BuildForAMD_X86_64)
        set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_x86_64AMD})
    else (BuildForAMD_X86_64)
        if (BuildForCore2_X86_64)
            set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptions_X86_64Core2})
        else (BuildForCore2_X86_64)
            set (CMAKE_CXX_FLAGS_RELEASE ${BuildOptionsBasic})
        endif (BuildForCore2_X86_64)
    endif (BuildForAMD_X86_64)
    message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
endif (BuildForDebug)

set (DSP_sources
    DSP/FFTwrapper.cpp  DSP/AnalogFilter.cpp  DSP/FormantFilter.cpp
    DSP/SVFilter.cpp  DSP/Filter.cpp  DSP/Unison.cpp
)

set (Effects_sources
    Effects/Alienwah.cpp  Effects/Chorus.cpp  Effects/Echo.cpp
    Effects/EffectLFO.cpp  Effects/EffectMgr.cpp  Effects/Effect.cpp
    Effects/Phaser.cpp  Effects/Reverb.cpp  Effects/EQ.cpp
    Effects/Distorsion.cpp  Effects/DynamicFilter.cpp
)

set (Misc_sources
    Misc/Config.cpp  Misc/SynthEngine.cpp  Misc/Bank.cpp  Misc/Microtonal.cpp
    Misc/Part.cpp  Misc/XMLwrapper.cpp  Misc/MiscFuncs.cpp
)

set (Params_sources
    Params/ADnoteParameters.cpp  Params/EnvelopeParams.cpp
    Params/FilterParams.cpp  Params/LFOParams.cpp
    Params/SUBnoteParameters.cpp  Params/PADnoteParameters.cpp
    Params/Controller.cpp  Params/Presets.cpp Params/PresetsStore.cpp
)

set (Synth_sources
    Synth/ADnote.cpp  Synth/Envelope.cpp  Synth/LFO.cpp  Synth/OscilGen.cpp
    Synth/SUBnote.cpp  Synth/Resonance.cpp  Synth/PADnote.cpp
    Synth/BodyDisposal.cpp
)

set (MusicIO_sources
    MusicIO/MusicClient.cpp  MusicIO/MusicIO.cpp  MusicIO/JackEngine.cpp
    MusicIO/AlsaEngine.cpp  MusicIO/JackClient.cpp  MusicIO/AlsaClient.cpp
    MusicIO/JackAlsaClient.cpp  MusicIO/AlsaJackClient.cpp MusicIO/WavRecord.cpp
)

add_definitions (
    -D'YOSHIMI_VERSION="${YOSHIMI_VERSION}"'
    -D'BASE_INSTALL_DIR="${CMAKE_INSTALL_PREFIX}"'
    ${ALSA_LDFLAGS}
    ${JACK_LDFLAGS}
    -DYOSHI_FIFO_DIR="${FifoDirectory}"
)

add_definitions (-DMAX_BANK_ROOT_DIRS=128)
add_definitions (-DMAX_AD_HARMONICS=128)
add_definitions (-DMAX_SUB_HARMONICS=64)
add_definitions (-DPAD_MAX_SAMPLES=64)
add_definitions (-DNUM_MIDI_PARTS=16)
add_definitions (-DNUM_MIDI_CHANNELS=16)
add_definitions (-DMAX_ENVELOPE_POINTS=40)

add_definitions (-DPI=3.1415926536f -DLOG_2=0.693147181f)

# these were previously (pointlessly) user configurable
add_definitions (-DNUM_VOICES=8)
add_definitions (-DPOLIPHONY=60)
add_definitions (-DNUM_SYS_EFX=4)
add_definitions (-DNUM_INS_EFX=8)
add_definitions (-DNUM_PART_EFX=3)
add_definitions (-DNUM_KIT_ITEMS=16)
add_definitions (-DVELOCITY_MAX_SCALE=8.0f)
add_definitions (-DMAX_EQ_BANDS=8) # MAX_EQ_BANDS must be less than 20")
add_definitions (-DMAX_FILTER_STAGES=5)
add_definitions (-DFF_MAX_VOWELS=6)
add_definitions (-DFF_MAX_FORMANTS=12)
add_definitions (-DFF_MAX_SEQUENCE=8)
add_definitions (-DMAX_PHASER_STAGES=12)
add_definitions (-DMAX_ALIENWAH_DELAY=100)

if (${DefaultAudio} STREQUAL "jack")
    message(STATUS "Default audio driver is Jack")
    add_definitions(-DDEFAULT_AUDIO=jack_audio)
elseif (${DefaultAudio} STREQUAL "alsa")
    message(STATUS "Default audio driver is Alsa")
    add_definitions(-DDEFAULT_AUDIO=alsa_audio)
else (${DefaultAudio} STREQUAL "alsa")
    message(FATAL_ERROR "Invalid DefaultAudio selection: " ${DefaultAudio})
endif (${DefaultAudio} STREQUAL "jack")

if (${DefaultMidi} STREQUAL "jack")
    message(STATUS "Default midi driver is Jack")
    add_definitions(-DDEFAULT_MIDI=jack_midi)
elseif (${DefaultMidi} STREQUAL "alsa")
    message(STATUS "Default midi driver is Alsa")
    add_definitions(-DDEFAULT_MIDI=alsa_midi)
else (${DefaultMidi} STREQUAL "alsa")
    message(FATAL_ERROR "Invalid DefaultMidi selection: " ${DefaultMidi})
endif (${DefaultMidi} STREQUAL "jack")

if (JackSessionSupport)
    message(STATUS "With jack session support")
    add_definitions(-DJACK_SESSION)
else (JackSessionSupport)
    message(STATUS "Without jack session support")
endif (JackSessionSupport)

set (ProgSources
    ${yoshimi_FLTK_UI_SRCS}
    ${DSP_sources}
    ${Effects_sources}
    ${Misc_sources}
    ${Params_sources}
    ${Synth_sources}
    ${MusicIO_sources}
)

include_directories (AFTER
    ${FFTW3F_INC_DIR}
    ${MXML_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${FONTCONFIG_INCLUDE_DIRS}
    ${FLTK_INCLUDE_DIR}
)

set(ExternLibraries
    ${FFTW3F_LIBRARIES}
    ${FONTCONFIG_LIBRARIES}
    ${FLTK_LIBRARIES}
    ${MXML_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${JACK_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    z
)

add_executable (yoshimi ${ProgSources} main.cpp)

target_link_libraries (yoshimi ${ExternLibraries})

install (TARGETS yoshimi RUNTIME DESTINATION bin)

install (DIRECTORY ../banks DESTINATION share/yoshimi
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ GROUP_WRITE
        WORLD_READ
    DIRECTORY_PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_WRITE GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

install (DIRECTORY ../presets DESTINATION share/yoshimi
    FILE_PERMISSIONS
        OWNER_READ OWNER_WRITE
        GROUP_READ GROUP_WRITE
        WORLD_READ
    DIRECTORY_PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_WRITE GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

set_directory_properties (PROPERTIES
    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_SOURCE_DIR}/*UI.c* ${CMAKE_SOURCE_DIR}/src/*UI.h"
)

add_custom_target (showversion
    COMMAND echo -n "Version: "
    COMMAND cat version.txt
    COMMAND echo
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# clean sweep
add_custom_target (distclean

=== debian/changelog ===
yoshimi (0.060.5-1) experimental; urgency=low

  * New upstream release.
  * Bump Standards.
  * Refresh patch.

 -- Alessio Treglia <alessio@debian.org>  Tue, 28 Dec 2010 13:41:52 +0100

yoshimi (0.060.3.1-1) experimental; urgency=low

  * Imported Upstream version 0.060.3.1
  * Upstream's changelog is not available anymore.
  * Install the presets too.
  * Refresh build flags patch.

 -- Alessio Treglia <alessio@debian.org>  Wed, 22 Dec 2010 09:50:43 +0100

yoshimi (0.060.1-1) experimental; urgency=low

  * New upstream release.
  * debian/gbp.conf: Add sign-tags = True
  * Refresh debian/patches/01-gcc_flags.patch.
  * Drop debian/patches/02-userconfig_path.patch, upstream has acknowledged
    and fixed the issue another way.
  * debian/control:
    - Build against experimental's JACK to have the session support.
    - Build-depend on libboost-dev.

 -- Alessio Treglia <alessio@debian.org>  Mon, 06 Dec 2010 11:13:40 +0100

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,13 @@
  cmake,
  sharutils,
  libx11-dev,
+ libboost-dev,
  fluid,
  libfltk1.1-dev,
  libmxml-dev,
  libfftw3-dev,
  libsndfile1-dev,
- libjack-dev,
+ libjack-dev (>= 1:0.118+svn4089-1~) | libjack-jackd2-dev (>= 1.9.6~dfsg.1-3~),
  libasound2-dev,
  libfontconfig1-dev,
  dpkg-dev (>= 1.14.17),
@@ -21,7 +22,7 @@
  libgl1-mesa-dev | libgl-dev,
  libglu1-mesa-dev | libglu-dev
 DM-Upload-Allowed: yes
-Standards-Version: 3.9.0
+Standards-Version: 3.9.1
 Vcs-Git: git://git.debian.org/git/pkg-multimedia/yoshimi.git
 Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/yoshimi.git
 Homepage: http://yoshimi.sourceforge.net

=== debian/rules ===
--- 
+++ 
@@ -9,9 +9,6 @@
 %:
 	dh --sourcedirectory=src $@
 
-override_dh_installchangelogs:
-	dh_installchangelogs README.txt
-
 override_dh_install:
 	dh_install
 	uudecode $(CURDIR)/debian/yoshimi.uu

## yoshimi 0.060.10

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #
 #   CMakeLists.txt
 #
-#   Copyright 2009-2010, Alan Calvert
+#   Copyright 2009-2011, Alan Calvert
 #
 #   This file is part of yoshimi, which is free software: you can
 #   redistribute it and/or modify it under the terms of the GNU General
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "0.060.5")
+set (YOSHIMI_VERSION "0.060.10")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -45,14 +45,14 @@
     {
         jack_session_event_type_t x = JackSessionSave;
         return 0;
-    }" HAS_JACK_SESSION
-)
-
-if (HAS_JACK_SESSION)
+    }" HasJackSession
+)
+
+if (HasJackSession)
     option (JackSessionSupport "Include Jack Session Support" ON)
-else (HAS_JACK_SESSION)
-    option (JackSessionSupport "Include Jack Session Support" OFF)
-endif (HAS_JACK_SESSION)
+else (HasJackSession)
+    set (JackSessionSupport OFF)
+endif (HasJackSession)
 
 set (DefaultAudio jack CACHE STRING "Default audio driver - alsa or jack")
 set (DefaultMidi jack CACHE STRING "Default midi driver - alsa or jack")
@@ -108,7 +108,7 @@
 # fftw3f
 pkg_check_modules (FFTW3F REQUIRED fftw3f>=0.22)
 if (FFTW3F_FOUND)
-    set (FFTW3F_LIBRARIES "${FFTW3F_LIBRARIES};fftw3f_threads")
+    set (FFTW3F_LIBRARIES "${FFTW3F_LIBRARIES}")
     message (STATUS "Found fftw3f ${FFTW3F_VERSION}")
 else (FFTW3F_FOUND)
     message (FATAL_ERROR "fftw3f >=0.22 required but not found")
@@ -145,14 +145,6 @@
 else (Boost_FOUND)
     message (FATAL_ERROR "boost headers required, but not found")
 endif (Boost_FOUND)
-
-# libsndfile
-pkg_check_modules (LIBSNDFILE REQUIRED sndfile)
-if (LIBSNDFILE_FOUND)
-    message (STATUS "Found libsndfile ${LIBSNDFILE_VERSION}")
-else (LIBSNDFILE_FOUND)
-    message (FATAL_ERROR "libsndfile required but not found")
-endif (LIBSNDFILE_FOUND)
 
 # fontconfig
 pkg_check_modules (FONTCONFIG REQUIRED fontconfig>=0.22)
@@ -238,7 +230,7 @@
 set (MusicIO_sources
     MusicIO/MusicClient.cpp  MusicIO/MusicIO.cpp  MusicIO/JackEngine.cpp
     MusicIO/AlsaEngine.cpp  MusicIO/JackClient.cpp  MusicIO/AlsaClient.cpp
-    MusicIO/JackAlsaClient.cpp  MusicIO/AlsaJackClient.cpp MusicIO/WavRecord.cpp
+    MusicIO/JackAlsaClient.cpp  MusicIO/AlsaJackClient.cpp
 )
 
 add_definitions (
@@ -302,33 +294,49 @@
     message(STATUS "Without jack session support")
 endif (JackSessionSupport)
 
+# Check for jack latency API >= 0.120.1
+check_c_source_compiles (
+    "#include <jack/jack.h>
+    int main(int argc, char **argv)
+    {
+        if (jack_set_latency_callback)
+            return 0;
+        else
+            return 1;
+    }" HasJackLatency
+)
+
+if (HasJackLatency)
+    add_definitions(-DJACK_LATENCY)
+endif (HasJackLatency)
+
 set (ProgSources
-    ${yoshimi_FLTK_UI_SRCS}
-    ${DSP_sources}
-    ${Effects_sources}
     ${Misc_sources}
     ${Params_sources}
     ${Synth_sources}
+    ${DSP_sources}
+    ${Effects_sources}
     ${MusicIO_sources}
+    ${yoshimi_FLTK_UI_SRCS}
 )
 
 include_directories (AFTER
-    ${FFTW3F_INC_DIR}
     ${MXML_INCLUDE_DIRS}
     ${ALSA_INCLUDE_DIRS}
     ${JACK_INCLUDE_DIRS}
     ${FONTCONFIG_INCLUDE_DIRS}
     ${FLTK_INCLUDE_DIR}
+    ${FFTW3F_INC_DIR}
 )
 
 set(ExternLibraries
-    ${FFTW3F_LIBRARIES}
     ${FONTCONFIG_LIBRARIES}
     ${FLTK_LIBRARIES}
     ${MXML_LIBRARIES}
     ${ALSA_LIBRARIES}
     ${JACK_LIBRARIES}
     ${LIBSNDFILE_LIBRARIES}
+    ${FFTW3F_LIBRARIES}
     z
 )

=== debian/changelog ===
yoshimi (0.060.10-3) unstable; urgency=low

  * Refresh 01-gcc_flags.patch.
  * debian/patches/02-fluid_1.3.patch:
    - Since the 1.3.x series, Fluid no longer produces (empty)
      implementations for totally empty functions in .fl files.
      Thank you, Aaron! (Closes: #633476)

 -- Alessio Treglia <alessio@debian.org>  Mon, 11 Jul 2011 15:33:20 +0200

yoshimi (0.060.10-2) unstable; urgency=low

  * Build-Depend on libjack-dev only (Closes: #628711).
  * Demote jackd to Recommends as yoshimi could be used without it.
  * Enable parallel builds.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Wed, 01 Jun 2011 12:39:37 +0200

yoshimi (0.060.10-1) unstable; urgency=low

  * New upstream release:
    - COPYING file updated.
    - licence anomalies corrected.
  * Update debian/copyright.
    - Update licensing,copyright information.
    - Comply with DEP-5 rev.174.

 -- Alessio Treglia <alessio@debian.org>  Tue, 12 Apr 2011 12:18:22 +0200

yoshimi (0.060.8-2) unstable; urgency=low

  * Provide -DBG package.

 -- Alessio Treglia <alessio@debian.org>  Mon, 11 Apr 2011 20:13:44 +0200

yoshimi (0.060.8-1) unstable; urgency=low

  * New upstream release.
  * Upload to unstable.
  * Improve description.

 -- Alessio Treglia <alessio@debian.org>  Wed, 06 Apr 2011 10:00:04 +0200

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends: debhelper (>= 7.0.50~),
 cmake,
 sharutils,
 libx11-dev,
 libboost-dev,
 fluid,
 libfltk1.1-dev,
 libmxml-dev,
 libfftw3-dev,
 libsndfile1-dev,
 libjack-dev,
 libasound2-dev,
 libfontconfig1-dev,
 dpkg-dev (>= 1.14.17),
 libxinerama-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-multimedia/yoshimi.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/yoshimi.git
Homepage: http://yoshimi.sourceforge.net

Package: yoshimi
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 yoshimi-data
Recommends: jackd
Description: software synthesizer based on ZynAddSubFX
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi delivers the same synthesizer capabilities along with 
 very good Jack and Alsa midi/audio functionality on Linux.

Package: yoshimi-data
Architecture: all
Depends: ${misc:Depends}
Recommends: yoshimi
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-dbg
Section: debug
Priority: extra
Architecture: any
Depends: yoshimi (= ${binary:Version}),
 ${misc:Depends}
Description: Debugging symbols for Yoshimi
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 This package provides the debugging symbols for yoshimi.

## yoshimi 0.060.12

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "0.060.10")
+set (YOSHIMI_VERSION "0.060.12")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)

=== debian/changelog ===
yoshimi (0.060.12-2) unstable; urgency=low

  * Fix missing #includes to solve FTBFS with GCC 4.7. (Closes: #672002)
  * Update debian/copyright to machine-readable format.
  * Bump standards.

 -- Alessio Treglia <alessio@debian.org>  Tue, 08 May 2012 15:57:18 -0700

yoshimi (0.060.12-1) unstable; urgency=low

  * New upstream release.
  * Remove 02-fluid_1.3.patch, applied upstream.

 -- Alessio Treglia <alessio@debian.org>  Thu, 05 Jan 2012 15:12:50 +0100

=== debian/control ===
Source: yoshimi
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 cmake,
 debhelper (>= 7.0.50~),
 dpkg-dev (>= 1.14.17),
 fluid,
 libasound2-dev,
 libboost-dev,
 libfftw3-dev,
 libfltk1.1-dev,
 libfontconfig1-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libjack-dev,
 libmxml-dev,
 libsndfile1-dev,
 libx11-dev,
 libxinerama-dev,
 sharutils
DM-Upload-Allowed: yes
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/git/pkg-multimedia/yoshimi.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/yoshimi.git
Homepage: http://yoshimi.sourceforge.net

Package: yoshimi
Architecture: any
Depends:
 yoshimi-data,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 jackd
Description: software synthesizer based on ZynAddSubFX
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 Yoshimi delivers the same synthesizer capabilities along with
 very good Jack and Alsa midi/audio functionality on Linux.

Package: yoshimi-data
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 yoshimi
Description: Presets for Yoshimi
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 This package provides banks and presets for Yoshimi.

Package: yoshimi-dbg
Section: debug
Priority: extra
Architecture: any
Depends:
 yoshimi (= ${binary:Version}),
 ${misc:Depends}
Description: Debugging symbols for Yoshimi
 Yoshimi is a software synthesizer for GNU/Linux, based on
 ZynAddSubFX 2.4.0.
 .
 This package provides the debugging symbols for yoshimi.

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 endif
 
 %:
-	dh --sourcedirectory=src $@
+	dh $@ --parallel --sourcedirectory=src
 
 override_dh_install:
 	dh_install
@@ -17,3 +17,5 @@
 	install -m 644 $(CURDIR)/debian/yoshimi.desktop $(CURDIR)/debian/yoshimi/usr/share/applications
 	install -m 644 $(CURDIR)/yoshimi.png $(CURDIR)/debian/yoshimi/usr/share/icons
 
+override_dh_strip:
+	dh_strip --dbg-package=yoshimi-dbg

## yoshimi 1.0.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "0.060.12")
+set (YOSHIMI_VERSION "1.0.0")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -197,6 +197,11 @@
     message (STATUS "Building for ${CMAKE_BUILD_TYPE}, flags: ${CMAKE_CXX_FLAGS_RELEASE}")
 endif (BuildForDebug)
 
+configure_file(
+    "${CMAKE_CURRENT_SOURCE_DIR}/../desktop/yoshimi.desktop.in"
+    "${CMAKE_CURRENT_BINARY_DIR}/yoshimi.desktop"
+    IMMEDIATE @ONLY)
+
 set (DSP_sources
     DSP/FFTwrapper.cpp  DSP/AnalogFilter.cpp  DSP/FormantFilter.cpp
     DSP/SVFilter.cpp  DSP/Filter.cpp  DSP/Unison.cpp
@@ -368,16 +373,8 @@
         WORLD_READ WORLD_EXECUTE
 )
 
-set_directory_properties (PROPERTIES
-    ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_SOURCE_DIR}/*UI.c* ${CMAKE_SOURCE_DIR}/src/*UI.h"
-)
-
-add_custom_target (showversion
-    COMMAND echo -n "Version: "
-    COMMAND cat version.txt
-    COMMAND echo
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-)
-
-# clean sweep
-add_custom_target (distclean
+install (FILES ${CMAKE_CURRENT_BINARY_DIR}/yoshimi.desktop
+    DESTINATION share/applications)
+install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/../desktop/yoshimi.png
+    DESTINATION share/pixmaps)
+

=== debian/changelog ===
yoshimi (1.0.0-1) unstable; urgency=low

  * New upstream release.
  * Remove patches applied upstream:
    - debian/patches/02-gcc47.patch

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 19 Jul 2012 15:56:33 +0200

## yoshimi 1.1.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "1.0.0")
+set (YOSHIMI_VERSION "1.1.0")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -154,6 +154,16 @@
 else(FONTCONFIG_FOUND)
     message (FATAL_ERROR "fontconfig>=0.22 required but not found")
 endif(FONTCONFIG_FOUND)
+
+
+# libcairo
+pkg_check_modules (LIBCAIRO REQUIRED cairo)
+if (LIBCAIRO_FOUND)
+    message (STATUS "Found libcairo ${LIBCAIRO_VERSION}")
+else (LIBCAIRO_FOUND)
+    message (FATAL_ERROR "libcairo required but not found")
+endif (LIBCAIRO_FOUND)
+
 
 # fltk
 find_package (FLTK REQUIRED)
@@ -249,7 +259,7 @@
 add_definitions (-DMAX_BANK_ROOT_DIRS=128)
 add_definitions (-DMAX_AD_HARMONICS=128)
 add_definitions (-DMAX_SUB_HARMONICS=64)
-add_definitions (-DPAD_MAX_SAMPLES=64)
+add_definitions (-DPAD_MAX_SAMPLES=96)
 add_definitions (-DNUM_MIDI_PARTS=16)
 add_definitions (-DNUM_MIDI_CHANNELS=16)
 add_definitions (-DMAX_ENVELOPE_POINTS=40)
@@ -332,6 +342,7 @@
     ${FONTCONFIG_INCLUDE_DIRS}
     ${FLTK_INCLUDE_DIR}
     ${FFTW3F_INC_DIR}
+    ${LIBCAIRO_INCLUDE_DIRS}
 )
 
 set(ExternLibraries
@@ -342,6 +353,7 @@
     ${JACK_LIBRARIES}
     ${LIBSNDFILE_LIBRARIES}
     ${FFTW3F_LIBRARIES}
+    ${LIBCAIRO_LIBRARIES}
     z
 )
 
@@ -369,12 +381,3 @@
         WORLD_READ
     DIRECTORY_PERMISSIONS
         OWNER_READ OWNER_WRITE OWNER_EXECUTE
-        GROUP_READ GROUP_WRITE GROUP_EXECUTE
-        WORLD_READ WORLD_EXECUTE
-)
-
-install (FILES ${CMAKE_CURRENT_BINARY_DIR}/yoshimi.desktop
-    DESTINATION share/applications)
-install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/../desktop/yoshimi.png
-    DESTINATION share/pixmaps)
-

=== debian/changelog ===
yoshimi (1.1.0-2) unstable; urgency=low

  * Set dh/compat 9
  * Small change in patch description.
  * Added patch to fix FTBS with compat 9.
    Thanks to Sebastian Ramacher <sramacher@debian.org>.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 19 Aug 2013 04:30:36 +0200

yoshimi (1.1.0-1) unstable; urgency=low

  * New upstream release.
  * Added libcairo2-dev as build dep.
  * Added patch fixing some spelling issues.
  * Installing new yoshimi icon.
  * Fix VCS canonical URLs.
  * Bump standards.
  * Added Keywords entry to desktop file.
  * Set dh/compat 8.
  * .gitignore file tuned.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 04 Jun 2013 23:47:33 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
  cmake,
- debhelper (>= 7.0.50~),
+ debhelper (>= 9),
  dpkg-dev (>= 1.14.17),
  fluid,
  libasound2-dev,
@@ -22,11 +22,11 @@
  libsndfile1-dev,
  libx11-dev,
  libxinerama-dev,
+ libcairo2-dev,
  sharutils
-DM-Upload-Allowed: yes
-Standards-Version: 3.9.3
-Vcs-Git: git://git.debian.org/git/pkg-multimedia/yoshimi.git
-Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/yoshimi.git
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/pkg-multimedia/yoshimi.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/yoshimi.git
 Homepage: http://yoshimi.sourceforge.net
 
 Package: yoshimi

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,10 @@
 
 override_dh_install:
 	dh_install
-	uudecode $(CURDIR)/debian/yoshimi.uu
 	install -d $(CURDIR)/debian/yoshimi/usr/share/applications
 	install -d $(CURDIR)/debian/yoshimi/usr/share/icons
 	install -m 644 $(CURDIR)/debian/yoshimi.desktop $(CURDIR)/debian/yoshimi/usr/share/applications
-	install -m 644 $(CURDIR)/yoshimi.png $(CURDIR)/debian/yoshimi/usr/share/icons
+	install -m 644 $(CURDIR)/desktop/yoshimi.png $(CURDIR)/debian/yoshimi/usr/share/icons
 
 override_dh_strip:
 	dh_strip --dbg-package=yoshimi-dbg

=== debian/watch ===
version=3

http://sf.net/yoshimi/yoshimi-([\d.]+)\.tar\.bz2

## yoshimi 1.2.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "1.1.0")
+set (YOSHIMI_VERSION "1.2.2")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -175,6 +175,7 @@
 mark_as_advanced (FLTK_DIR)
 mark_as_advanced (FLTK_FLUID_EXECUTABLE)
 mark_as_advanced (FLTK_MATH_LIBRARY)
+
 set (GuiFluids
     UI/WidgetPDialUI.fl  UI/PresetsUI.fl  UI/EnvelopeUI.fl
     UI/LFOUI.fl  UI/FilterUI.fl  UI/VirKeyboardUI.fl
@@ -355,6 +356,7 @@
     ${FFTW3F_LIBRARIES}
     ${LIBCAIRO_LIBRARIES}
     z
+    dl
 )
 
 add_executable (yoshimi ${ProgSources} main.cpp)
@@ -380,4 +382,3 @@
         GROUP_READ GROUP_WRITE
         WORLD_READ
     DIRECTORY_PERMISSIONS
-        OWNER_READ OWNER_WRITE OWNER_EXECUTE

=== debian/changelog ===
yoshimi (1.2.2-1) unstable; urgency=low

  * Imported Upstream version 1.2.2

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 01 Jul 2014 20:01:45 +0200

yoshimi (1.2.1-1) unstable; urgency=low

  * Imported Upstream version 1.2.1
  * Removed/Refreshed patches - applied upstream.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 10 Jun 2014 01:16:11 +0200

yoshimi (1.2.0-1) unstable; urgency=low

  * Imported Upstream version 1.2.0
  * Bump Standards.
  * Patch refreshed.
  * Added patch to fix FTBFS.
  * Spelling patch removed - not applying anymore.
  * Added patch to fix hardening.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 20 Mar 2014 18:39:52 +0100

## yoshimi 1.2.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 cmake_minimum_required (VERSION 2.6)
 cmake_policy (VERSION 2.6)
 cmake_policy (SET CMP0004 OLD)
-set (YOSHIMI_VERSION "1.2.2")
+set (YOSHIMI_VERSION "1.2.4")
 file (WRITE version.txt "${YOSHIMI_VERSION}")
 
 set (CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -265,7 +265,10 @@
 add_definitions (-DNUM_MIDI_CHANNELS=16)
 add_definitions (-DMAX_ENVELOPE_POINTS=40)
 
-add_definitions (-DPI=3.1415926536f -DLOG_2=0.693147181f)
+add_definitions (-DPI=3.1415926536f)
+add_definitions (-DTWOPI=6.28318530718f)
+add_definitions (-DHALFPI=1.57079632679f)
+add_definitions (-DLOG_2=0.693147181f)
 
 # these were previously (pointlessly) user configurable
 add_definitions (-DNUM_VOICES=8)
@@ -379,6 +382,3 @@
 install (DIRECTORY ../presets DESTINATION share/yoshimi
     FILE_PERMISSIONS
         OWNER_READ OWNER_WRITE
-        GROUP_READ GROUP_WRITE
-        WORLD_READ
-    DIRECTORY_PERMISSIONS

=== debian/changelog ===
yoshimi (1.2.4-1) unstable; urgency=low

  * Imported Upstream version 1.2.4
  * Fix typo in copyright file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 03 Oct 2014 16:15:24 +0200

yoshimi (1.2.3-1) unstable; urgency=low

  * Imported Upstream version 1.2.3

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 30 Aug 2014 13:36:09 +0300

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
  libxinerama-dev,
  libcairo2-dev,
  sharutils
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/yoshimi.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/yoshimi.git
 Homepage: http://yoshimi.sourceforge.net
